/***************************************
	Auteur : Pierre Aubert
	Mail : pierre.aubert@lapp.in2p3.fr
	Licence : CeCILL-C
****************************************/

// CPU: g++ -std=c++17 test.cpp -ltbb -o test_gnu_cpu
// GPU: nvc++ -stdpar=gpu -std=c++14 test.cpp -o test_pgi_gpu

#include <vector>
#include <functional>
#include <iostream>
#include <numeric>
#include <execution>

int main(){
	std::vector<double> xvalues(100, 1.0);
	std::iota(xvalues.begin(), xvalues.end(), 0);
	double result = std::transform_reduce(
		std::execution::par,
		xvalues.begin(), xvalues.end(),
		0.0, std::plus<>(),
		[](double x) { return x*x;});
	std::cout << result << std::endl;
	return 0;
}


